
 
%macro Excel_Enhance(open_workbook=,
                  insert_workbook=,
                  insert_sheet=,
                  move_table=,
                  insert_image=,
                  create_workbook=,
                  file_format=);

 %local open_workbook insert_sheet insert_image create_workbook file_format;
 %let script_loc=%sysfunc(getoption(WORK))\enhance.vbs;

data _null_;

  file "&script_loc";
  put "Set objExcel = CreateObject(""Excel.Application"") ";
  put "objExcel.Visible = False";
  put "objExcel.DisplayAlerts=False";
  put "Set objWorkbook1= objExcel.Workbooks.Open(""&open_workbook"")";

  %if %length(&insert_image) ne 0 %then %do;
    %let pic_count=%sysfunc(countc(&insert_image,","));
    %if %sysfunc(countc(&insert_image,","))=0 %then %do;
      %let sheet_name=%sysfunc(scan(&insert_image,2,"#"));
      %let range_field=%sysfunc(scan(&insert_image,2,"!"));
      %let image_loc=%sysfunc(scan("&insert_image",1,"#"));
      sheet_name=quote(scan("&sheet_name",1,"!"));
      range_field=quote("&range_field");
      image_loc=quote("&image_loc");
      put "Set Xlsheet1 = objWorkbook1.Worksheets(" sheet_name ")";
      put "Xlsheet1.Range(" range_field ").Activate";
      put "Xlsheet1.Pictures.Insert(" image_loc ")";
    %end; /* END %if %sysfunc(countc(&insert_image,","))=0 %then %do; */
    %else %do;
      %let image_count=%sysfunc(countc(&insert_image,","));
      %let image_count=%eval(&image_count+1);
      %do j=1 %to &image_count;
        %let insert_image&j=%sysfunc(scan(&&insert_image,&j,","));
        %let sheet_name&j=%sysfunc(scan(&&insert_image&j,2,"#"));
        %let sheet_name&j=%quote(%str(%")%sysfunc(scan(&&sheet_name&j,1,"!"))%str(%"));
        %let range_field&j=%quote(%str(%")%sysfunc(scan(&&insert_image&j,2,"!"))%str(%"));
        %let image_loc&j=%quote(%str(%")%sysfunc(scan("&&insert_image&j",1,"#"))%str(%"));
        sheet_name=quote(scan("&&sheet_name&j",1,"!"));
        range_field=quote("&&range_field&j");
        image_loc=quote("&&image_loc&j");
        put;
        put "Set Xlsheet = objWorkbook1.Worksheets( &&sheet_name&j)";
        put "Xlsheet.Range(&&range_field&j).Activate";
        put "Xlsheet.Pictures.Insert(&&image_loc&j)";
      %end; 
    %end; 
  %end; 

  %if %length(&insert_workbook) ne 0 %then %do;
      put;
      put "set objWorkbook2=objExcel.Workbooks.Open(""&insert_workbook"")";
      %let sheet_count=%sysfunc(countc(&insert_sheet,","));
      %let sheet_count=%eval(&sheet_count+1);
      %do i=1 %to &sheet_count;
        %let x=%sysfunc(scan(&insert_sheet,&i));
        %if &i=1 
        %then %let s&i=%sysfunc(quote(&x));
        %else %let s&i=&s%eval(&i-1),%sysfunc(quote(&x)) ;
        %let list=%nrbquote(&&s&i);
      %end;
      put "set sheetsToCopy=objWorkbook2.Sheets(Array(%quote(&list))) ";
      put "sheetsToCopy.Copy objWorkbook1.Sheets(1) ";
  %end;

  %if %length(&move_table) ne 0 %then %do;
    %if %sysfunc(countc(&move_table,",")) = 0 %then %do;
      %let move_range=%sysfunc(scan(&move_table,1,"!"));
      %let paste_location=%sysfunc(scan(&move_table,2,"!"));
      %put &move_range &paste_location;
      put;
      put "Set objWorksheet = objWorkbook1.Worksheets(1)"; 
      put "objWorksheet.Activate";
      put "Set objRange = objWorkSheet.Range(""&move_range"")";     
      put "objRange.Copy"; 
      put "Set objRange = objWorkSheet.Range(""&paste_location"")";     
      put "objWorksheet.Paste(objRange)";
      put "Set objRange1 = objWorkSheet.Range(""&move_range"")";
      put "objRange1.Delete"; 
    %end;  
    %else %do;
      %let countx=%sysfunc(countc(&move_table,","));
      %let countx=%eval(&countx+1);
      put "Set objWorksheet = objWorkbook1.Worksheets(1)"; 
	  put "objWorksheet.Activate";
      %do j=1 %to &countx;
        %let move_range&j=%sysfunc(scan(&move_table,&j,","));
	    %let move_range_only&j=%sysfunc(scan(&&move_range&j,1,"!"));
	    %let paste_location&j=%sysfunc(scan(&&move_range&j,2,"!"));
	    %put  'move=' &&move_range&j 'paste_location' &&paste_location&j;
	    put;
	    put "Set objRange = objWorkSheet.Range(""&&move_range_only&j"")";     
	    put "objRange.Copy"; 
	    put "Set objRange = objWorkSheet.Range(""&&paste_location&j"")";     
	    put "objWorksheet.Paste(objRange)";
	    put "Set objRange1 = objWorkSheet.Range(""&&move_range_only&j"")";
	    put "objRange1.Delete";         
      %end; 
    %end;
  %end;

  %if %length(&file_format) ne 0 %then %do;
    %if &file_format=xlsx %then %let file_formatn=51;
    %else %if &file_format=xls %then %let file_formatn=1;
    %else %if &file_format=csv %then %let file_formatn=16;
  %end;

  %if %length(&create_workbook) ne 0 %then %do;
    %if %length(&file_format) ne 0 
    %then %let save="objWorkbook1.saveAs ""&create_workbook"",&file_formatn";
    %else %let save="objWorkbook1.saveAs(""&create_workbook"")";
    put &save;
  %end;
  %else %do;
    %let name=%sysfunc(scan(%sysfunc(reverse(%sysfunc(scan(%sysfunc(reverse(&open_workbook)),2)))),1,"."))_update.&file_format;
    %put &name;
    %if %length(&file_format) ne 0 
    %then %let save="objWorkbook1.saveAs ""&name"",&file_formatn";
    %else %let save="objWorkbook1.saveAs(""&name"")";
    put &save;
  %end;

   put "objWorkbook1.close";
   put "objExcel.DisplayAlerts=True";
   put "set objExcel=nothing";
   
run;

x "'&script_loc\'";

%mend Excel_Enhance;